/*
FBullCowGame class
Class for the game logic of the Bulls and Cows game.
Has no user interaction. game is based on Mastermind. 
[C] Copyright 2018: Pranjal Rastogi|Pjr incorporated|Pjr DevSys.
*/

#pragma once
#include <string>

// to make unreal friendly
using FString = std::string;
using int32 = int;

struct FBullCowCount
{
	int32 Bulls = 0;
	int32 Cows = 0;
};

enum class EGuessStatus
{
	Invalid_Status,
	OK,
	Not_Isogram,
	Wrong_Length,
	Not_Lowercase,
};

class FBullCowGame 
{
public:
	FBullCowGame(); // constructor.

	int32 GetMaxTries() const;
	int32 GetCurrentTry() const;
	int32 GetHiddenWordLength() const;
	bool IsGameWon() const;
	
	EGuessStatus CheckGuessValidity(FString) const; 
	
	void Reset();
	FBullCowCount SubmitValidGuess(FString);

// Look up
private:
	// see constructor for initialization
	int32 MyCurrentTry;
	FString MyHiddenWord;
	bool bGameIsWon;

	bool IsIsogram(FString) const;
	bool IsLowercase(FString) const;
};
